/* global describe */
/* global it */

import devConfig from '../lib/webpack/buildTypes/devServer';

describe('test the dev configuration', () => {
  it('ensure bundled js name', () => {
    expect(devConfig.output.filename).toEqual('index.js');
  });

  it('ensure devServer configuration', () => {
    let devServer = devConfig.devServer;
    expect(devServer.contentBase).toEqual('./src/');
    expect(devServer.port).not.toBeUndefined();
    expect(devConfig.output.filename).toEqual('index.js');
  });

  it('ensure correct extensions', () => {
    expect(devConfig.resolve.extensions).toEqual(['.js', '.jsx']);
  });

  it('ensure correct modules resolve', () => {
    expect(devConfig.resolve.modules).toBeUndefined();
  });

  it('ensure correct plugins', () => {
    let requiredPlugins = {
      ExtractTextPlugin : 'ExtractTextPlugin'
    };
    devConfig.plugins.forEach((item) => {
      delete (requiredPlugins[item.constructor.name]);
    });
    expect(requiredPlugins).toEqual({});
  });

  it('Ensure custom port is passed', () => {
    expect(devConfig.devServer.port).toEqual(8000);
  });
});