import distConfig from '../lib/webpack/buildTypes/static';

describe('test the dist configuration', () => {
  it('ensure correct dist directory', () => {
    let distPath;
    distPath = distConfig.output.path.replace(process.cwd(), '').replace('/', '');

        // this is a hard dependency, we expect it to be specifically dist.
        // if any component wants to change it, they'll have to change it in their own webpack config override
    expect(distPath).toBe('dist');
  });

  it('ensure libraryTarget building', () => {
    expect(distConfig.output.libraryTarget).toEqual('umd');
  });

  it('ensure bundled js name', () => {
    expect(distConfig.output.filename).toEqual('[name].js');
  });

  it('ensure correct extensions', () => {
    expect(distConfig.resolve.extensions).toEqual(['.js', '.jsx']);
  });

  it('ensure correct modules resolve', () => {
    expect(distConfig.resolve.modules).toBeUndefined();
  });

  it('ensure correct plugins', () => {
    let requiredPlugins = {
      UglifyJsPlugin :'UglifyJsPlugin',
      AggressiveMergingPlugin : 'AggressiveMergingPlugin',
      ExtractTextPlugin : 'ExtractTextPlugin'
    };
    distConfig.plugins.forEach((item) => {
      delete (requiredPlugins[item.constructor.name]);
    });
    expect(requiredPlugins).toEqual({});
  });
});