/* eslint no-console:0 */
'use strict';
require('core-js/fn/object/assign');
const webpack = require('webpack');
const WebpackDevServer = require('webpack-dev-server');
const open = require('open');
const path = require('path');
const fs = require('fs');

let dllConfig = require('../lib/webpack/webpackConfig')('dll');
let compiler = webpack(dllConfig);
compiler.run((err, stats) => {
  process.env.REACT_WEBPACK_ENV = 'develop';

// this is the dev server webpack configuration
// in short, production is not the right name of the 'env'....
  let config = require(path.join(__dirname, '../lib/webpack/buildTypes/devServer'));

// TODO rename "webpackConfig.js" to something else...
  let extendablePath = path.join(`${__dirname}/../../../tools/` + 'webpackConfig.js');
  if (fs.existsSync(extendablePath)) {
    config = require(extendablePath)(config);
  }

  new WebpackDevServer(webpack(config), config.devServer)
    .listen(config.devServer.port, '0.0.0.0', (err) => {
      if (err) {
        console.log(err);
      }
      console.log(`Listening at localhost:${config.devServer.port}`);
      console.log('Opening your system browser...');
      open(`http://localhost:${config.devServer.port}/`);
    });
});

