let fs = require('fs');
let path = require('path');
let createJest = require('../lib/scripts/createFileSystem/createJest');
let copyStaticRootFiles = require('../lib/scripts/createFileSystem/copyStaticRootFiles');
let copyGitIgnore = require('../lib/scripts/createFileSystem/copyGitIgnore');
let createTestsDir = require('../lib/scripts/createFileSystem/createTestsDir');
let createSrc = require('../lib/scripts/createFileSystem/createSrc');
let createTutorialsDir = require('../lib/scripts/createFileSystem/createTutorialsDir');
let enrichPackageJson = require('../lib/scripts/createFileSystem/enrichPackageJson');
let copyReadMe = require('../lib/scripts/createFileSystem/copyReadMe');
let copyJsdocConfig = require('../lib/scripts/createFileSystem/copyJsdocConfig');

createJest(process.cwd());
copyStaticRootFiles(process.cwd());
copyGitIgnore(process.cwd());
createTestsDir(process.cwd());
createTutorialsDir(process.cwd());
createSrc(process.cwd());
enrichPackageJson(process.cwd());
copyReadMe(process.cwd());
copyJsdocConfig(process.cwd());
installDependencies(process.cwd());


function installDependencies(targetDir) {
  let jarbPackage = require('jarb/package.json');

  let projectPackage = JSON.parse(fs.readFileSync(path.join(targetDir, 'package.json')));
  let depsOfHostingProject = {};
  projectPackage.dependencies = projectPackage.dependencies || {};

  Object.keys(projectPackage.dependencies).forEach((depName) => {
    depsOfHostingProject[depName] = projectPackage.dependencies[depName];
  });

  Object.keys(projectPackage.devDependencies).forEach((depName) => {
    depsOfHostingProject[depName] = projectPackage.devDependencies[depName];
  });

  let execString = '';
  Object.keys(jarbPackage.devDependencies).forEach((depName) => {
    // if this module is required by the hosting project
    // we won't override it, we'll use the hosting project's version
    // this allows extending the original list of dependencies.
    if (!depsOfHostingProject[depName]) {
      let ver = jarbPackage.devDependencies[depName];
      execString += ` ${depName}@${ver}  `;
    }
  });

  console.log('Installing dependencies...');
  let execSync = require('child_process').execSync;
  execSync(`npm install --no-save ${execString}`, {stdio: [0, 1, 2]});
}
