#!/usr/bin/env node
let command = process.argv[2];

if (['init', 'help', 'build', 'devServer', 'test', 'tdd', 'analyze'].indexOf(command) === -1) {
  console.log('JARB: invalid command!, please select one of... [\'init\', \'help\', \'build\', \'devServer\', \'test\', \'tdd\', \'analyze\']');
}

let flags = {};
process.argv.forEach((arg) => {
  let flag;

  if (arg.indexOf('=') >= 0) {
    flag = arg.replace('--', '');

    let key = flag.split('=')[0];
    flags[key] = flag.split('=')[1];
  }
});

if (!flags.env) {
  flags.env = 'production';
}

process.env.JARB_FLAGS = JSON.stringify(flags);

if (command === 'init') {
  require('./init');
}

if (command === 'build') {
  if (flags.env === 'production') {
    process.env.NODE_ENV = 'production';
  } else  if (flags.env === 'staging') {
    process.env.NODE_ENV = 'staging';
  }
  require('./build');
}

if (command === 'devServer') {
  process.env.NODE_ENV = 'develop';
  require('./devServer');
}

if (command === 'test') {
  require('./test');
}

if (command === 'tdd') {
  require('./tdd');
}

if (command === 'analyze') {
  process.env.NODE_ENV = 'production';
  require('./analyze');
}