let {breakOnError, execWrap, log, fs, path} = require('./shared/bootstrap');

/**
 * Runs <code>npm run analyze</code> - Ensure it runs without an issue (no ece
 */
function npmRunAnalyze() {
  execWrap('npm run analyze', (err) => {
    let statsOK = fs.readFileSync('stats.json', 'utf8');
    if (err || !statsOK) {
      log('error running analyze');
      breakOnError();
    }
    log('OK - npm run analyze');
  });
}

module.exports = {
  npmRunAnalyze
};