let {breakOnError, execWrap, log, fs, path} = require('./shared/bootstrap');

/**
 * Runs <code>npm run test</code> - Ensures that coverage directory exists
 */
function npmRunTest() {
  execWrap('npm run test', (err) => {
    if (err || !fs.existsSync(path.resolve('coverage'))) {
      log('error running tests');
      breakOnError();
    }
    log('OK - npm run test');
  });
}

module.exports = {
  npmRunTest
};