let fs = require('fs');
let path = require('path');
let log = console.log;

let exec = require('child_process').exec;
let execWrap = (command, cb) => {
  let child = exec(command, cb);
  child.stderr.pipe(process.stderr);
  child.stdout.pipe(process.stdout);
};

// wrap process.exit
let breakOnError = function(reason) {
  log(reason);
  process.exit(1);
};

// listen to exit codes 1
process.on('exit', (code) => {
  if (code === 1) {
    log('An error occured - Unexpected exit');
  }
});

module.exports = {
  log,
  execWrap,
  breakOnError,
  path,
  fs
};