let ExtractTextPlugin = require('extract-text-webpack-plugin');
let envConfig = require('../../../scripts/util/config');

module.exports.rules = [
  {
    test: /\.css$/,
    use: ExtractTextPlugin.extract({
      fallback: 'style-loader',
      use: ['css-loader', 'postcss-loader'],
      publicPath: envConfig.webpackPublicPath
    })
  },
  {
    test: /\.scss$/,
    use: ExtractTextPlugin.extract({
      fallback: 'style-loader',
      use: ['css-loader',
        {
          loader: 'postcss-loader',
          options: {
            plugins: function() {
              return [
                require('autoprefixer')
              ];
            }
          }
        }, 'sass-loader'],
      publicPath: envConfig.webpackPublicPath
    })
  },
  {
    test: /\.(png|jpg|jpeg|gif|woff|woff2|eot|ttf|mp4|ogg|svg)$/,
    use: [`file-loader?name=[path][name].[ext]&publicPath=${envConfig.webpackPublicPath}`]
  }
];